function clientcmdRSC_Handshake()
{
	commandToServer('RSC_Handshake', $RSC::Revision);
	$RSC::RealSpaceServer = 1;
	showDirectionMarkers();
	RSC_HUDLoop();
	RSC_TransponderPing();
	RSC_Ambience();
}

function clientcmdUpdateMaterial(%amt, %mat)
{
	$RSC::MatRecord[-1+$RSC::MatRecords++] = %mat;
	$RSC::MatAmount[%mat] = %amt;
}

function clientcmdRSC_SetSSOffset(%offset)
{
	$RSC::SSOffset = %offset;
}

package RealSpaceClient
{
	function GameConnection::setConnectArgs(%a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o)
	{
		%j = %j@(%j$=""?"":"\t")@"RSC "@$RSC::Revision;
		$RSC::Jetpack = 0;
		RSC_MainHUD.setVisible(0);
		%count = RSC_DirMarkers.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%marker = RSC_DirMarkers.getObject(%i);
			if(getSubStr(%marker.markerName, 0, 7) $= "Player_")
				schedule(0, 0, "RSC_UpdateDirMarker", %marker.markerName, "DELETE");
		}
		RSC_PlayerList.delete();
		new ScriptObject(RSC_PlayerList);
		$RSC::MatRecords = 0;
		$RSC::RealSpaceServer = 0;
		cancel($RSC::TransponderPing);
		cancel($RSC::HUDLoop);
		cancel($RSC::Ambience);
		cancel($RSC::Ambience);
		for(%i=0;%i<$RSC::AmbVolume;%i++)
			alxStop($RSC::AmbHandle[%i]);
		return Parent::setConnectArgs(%a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o);
	}
	
	function disconnect(%a, %b, %c, %d, %e)
	{
		echo ("trying to disconnect");
		%r = getRealTime();
		$RSC::TutorialCourse = "";
		$RSC::TutorialStage = "";
		$RSC::BlockBuilding = 0;
		$RSC::BlockTools = 0;
		$RSC::BlockPainting = 0;
		$RSC::BlockClicking = 0;
		$RSC::BlockJumping = 0;
		$RSC::BlockJetting = 0;
		$RSC::BlockJetpack = 0;
		$RSC::TutorialActive = 0;
		$RSC::Jetpack = 0;
		RSC_MainHUD.setVisible(0);
		%count = RSC_PlayerList.playerMarkers;
		for(%i=0;%i<%count;%i++)
			schedule(0, 0, "RSC_UpdateDirMarker", "Player_"@%i, "DELETE");
		RSC_PlayerList.delete();
		new ScriptObject(RSC_PlayerList);
		$RSC::MatRecords = 0;
		$RSC::RealSpaceServer = 0;
		cancel($RSC::TransponderPing);
		cancel($RSC::HUDLoop);
		cancel($RSC::Ambience);
		cancel($RSC::Ambience);
		for(%i=0;%i<$RSC::AmbVolume;%i++)
			alxStop($RSC::AmbHandle[%i]);
		echo ("time: " @ vectorDist(getRealTime(), %r));
		return Parent::disconnect(%a, %b, %c, %d, %e);
	}
};
activatePackage("RealSpaceClient");

if(!$RealisticSpaceClientBound) { $remapDivision[$remapCount] = "Realistic Space Client"; $remapCount--; }

$RSC::Revision = 0;
exec("./GUIs/Main.cs");

exec("./Ambience.cs");
exec("./ByteArraySO.cs");
exec("./CSG.cs");
exec("./Float16.cs");
//exec("./Ghost Chat.cs");
exec("./Interact.cs");
exec("./Jetpack.cs");
exec("./Move Inds.cs");
exec("./Radio Chat.cs");

if(!$RealisticSpaceClientBound) { $RealisticSpaceClientBound = 1; $remapCount++; }