$RSC::Revision += 0;

if (isObject(RSC_SpeciesGUI))
	RSC_SpeciesGUI.delete();
new GuiControl(RSC_SpeciesGUI)
{
	visible = 0;
	
	new GuiBitmapCtrl(RSC_SpeciesWindow)
	{
		position = "200 100";
		extent = "960 276";
		bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Species GUI";
		
		new GuiBitmapCtrl()
		{
			position = "4 4";
			extent = "64 64";
			bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Species Icons/Human_Icon";
			
			new GuiBitmapButtonCtrl()
			{
				position = "0 0";
				extent = "64 64";
				bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Blank";
				command = "RSC_selectSpecies(\"Human\");";
				text = " ";
			};
		};
		
		new GuiBitmapCtrl()
		{
			position = "72 4";
			extent = "64 64";
			bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Species Icons/Robot_Icon";
			
			new GuiBitmapButtonCtrl()
			{
				position = "0 0";
				extent = "64 64";
				bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Blank";
				command = "RSC_selectSpecies(\"Robot\");";
				text = " ";
			};
		};
		
		new GuiBitmapCtrl()
		{
			position = "72 72";
			extent = "64 64";
			bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Species Icons/Zoltan_Icon";
			
			new GuiBitmapButtonCtrl()
			{
				position = "0 0";
				extent = "64 64";
				bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Blank";
				command = "RSC_selectSpecies(\"Zoltan\");";
				text = " ";
			};
		};
		
		new GuiBitmapCtrl(RSC_SpeciesPortrait)
		{
			position = "140 4";
			extent = "128 128";
			bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Blank_N";
		};
		
		new GuiMLTextCtrl(RSC_SpeciesText)
		{
			position = "272 4";
			extent = "680 267";
			text = "Select a species to see details.<br><color:FF8000>WARNING<color:000000>: You can only choose your species once!";
		};
		
		new GuiSwatchCtrl(RSC_ConfirmCover)
		{
			position = "178 135";
			extent = "88 20";
			color = "85 85 85 255";
		};
		
		new GuiBitmapButtonCtrl()
		{
			position = "178 135";
			extent = "88 20";
			bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Blank";
			command = "RSC_confirmSpecies();";
			text = " ";
		};
	};
};

function RSC_confirmSpecies()
{
	Canvas.popDialog(RSC_SpeciesGUI);
	commandToServer('species', "confirm", RSC_SpeciesGUI.selected);
}

function RSC_selectSpecies(%species)
{
	for (%i = 0; %i < 3; %i++)
		RSC_SpeciesWindow.getObject(%i).setColor("0.7 0.7 0.7 1");
	switch$(%species)
	{
		case "Human":
			RSC_SpeciesWindow.getObject(0).setColor("1 1 1 1");
			RSC_SpeciesText.setValue("    <font:arial:20>Species: Human<br><font:arial:14>Humans are the most adaptable of the known species, changing to new situations as they develop. However, this adaptability comes at a cost;"@
			" humans will never be able to compete with the Robotic abilities with computers, or the Zoltan abilities with bioelectricity.<br>    <font:arial:20><color:008000>Advantages<color:000000><br><font:arial:14>Humans wearing"@
			" the backpack have the most storage space of any species, at the cost of life support.<br>Humans are the most resistant of the known species to solar radiation.<br>Humans are highly general, allowing them to solve almost"@
			" any problem.<br>    <font:arial:20><color:800000>Disadvantages<color:000000><br><font:arial:14>Humans cannot specialize on a task as well as the other known races, limiting their relative ability in some fields.<br>Humans"@
			" do not have natural armor like the Robots, nor natural weapons like the Zoltan, and must rely on tools in combat.<br>    <font:arial:20><color:000080>Statistics<color:000000><br><font:arial:14>Storage: 25 kg, or 150"@
			" kg when wearing the backpack<br>Life support: 2 hours, or 20 minutes without oxygen tanks<br>Base mass: 50 kilograms<br>EVA tank size: 5 kg of hydrazine");
		case "Robot":
			RSC_SpeciesWindow.getObject(1).setColor("1 1 1 1");
			RSC_SpeciesText.setValue("    <font:arial:20>Species: Robot<br><font:arial:14>Robots are able to survive without air, food, or water, cannot be poisoned, and interface far better with computers than the organic species;"@
			" however, they are the most vulnerable of the known species to solar radiation, and can be stunned or even killed by Zoltan EMPs.<br>    <font:arial:20><color:008000>Advantages<color:000000><br><font:arial:14>Robots"@
			" can stay in depressurized areas indefinitely.<br>Robots are resistant to most forms of damage.<br>Robots are able to interface with computers almost instinctively.<br>    <font:arial:20><color:800000>Disadvantages<color:000000><br><font:arial:14>Robots"@
			" are the most vulnerable to solar radiation of any species, and are badly stunned if hit by a solar flare.<br>Robots can be stunned or damaged by electromagnetic weaponry.<br>    <font:arial:20><color:000080>Statistics<color:000000><br><font:arial:14>Storage:"@
			" 100kg<br>Life support: 24 minute emergency backup for rescues (12 minute for Zoltan)<br>Base mass: 60 kilograms<br>EVA tank size: 2.5 kg of hydrazine");
		case "Zoltan":
			RSC_SpeciesWindow.getObject(2).setColor("1 1 1 1");
			RSC_SpeciesText.setValue("    <font:arial:20>Species: Zoltan<br><font:arial:14>Zoltan are the smallest of the known species when fully grown, and can provide power to station systems with their innate bioelectric energy;"@
			" however, they are vulnerable to physical damage, and must use their natural bioelectricity to level the field of combat.<br>    <font:arial:20><color:008000>Advantages<color:000000><br><font:arial:14>Zoltan can power"@
			" electrical systems, allowing them to operate stations that have lost power.<br>Zoltan are smaller and lighter than the other species, letting them maneuver with greater power.<br>Zoltan can release electromagnetic pulses"@
			" which disrupt any nearby electronics.<br>    <font:arial:20><color:800000>Disadvantages<color:000000><br><font:arial:14>Zoltan have a fast metabolism, and consume oxygen faster than humans.<br>Zoltan have lower health"@
			" than humans, making them poor choices for direct combatants.<br>    <font:arial:20><color:000080>Statistics<color:000000><br><font:arial:14>Storage: 30 kg, or 60 kg when wearing the backpack<br>Life support: 1 hour,"@
			" or 10 minutes without oxygen tanks<br>Base mass: 30 kilograms<br>EVA tank size: 5 kg of hydrazine");
//																														|
		default:
			return;
	}
	RSC_SpeciesPortrait.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Species Icons/" @ %species);
	RSC_SpeciesGUI.selected = %species;
	RSC_ConfirmCover.setColor("0 0 0 0");
}