$RSC::Revision += 1;

if (!isObject(RSC_TutorialArrow))
	new GuiBitmapCtrl(RSC_TutorialArrow)
	{
		bitmap = "Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Down";
		extent = "80 80";
	};

package RSC_Tutorial
{
	function mouseFire(%tog) { if (!$RSC::BlockClicking) Parent::mouseFire(%tog); }
	function jump(%tog) { if (!$RSC::BlockJumping) Parent::jump(%tog); }
	function jet(%tog) { if (!$RSC::BlockJetting) Parent::jet(%tog); }
	function useBricks(%tog) { if (!$RSC::BlockBuilding) Parent::useBricks(%tog); }
	function useFirstSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useFirstSlot(%tog); }
	function useSecondSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useSecondSlot(%tog); }
	function useThirdSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useThirdSlot(%tog); }
	function useFourthSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useFourthSlot(%tog); }
	function useFifthSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useFifthSlot(%tog); }
	function useSixthSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useSixthSlot(%tog); }
	function useSeventhSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useSeventhSlot(%tog); }
	function useEighthSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useEighthSlot(%tog); }
	function useNinthSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useNinthSlot(%tog); }
	function useTenthSlot(%tog) { if (!$RSC::BlockBuilding) Parent::useTenthSlot(%tog); }
	function useTools(%tog) { if (!$RSC::BlockTools) Parent::useTools(%tog); }
	function useSprayCan(%tog) { if(!$RSC::BlockPainting) Parent::useSprayCan(%tog); }
	function invLeft(%tog) { if (!RSC_cancelInvMove()) Parent::invLeft(%tog); }
	function invRight(%tog) { if (!RSC_cancelInvMove()) Parent::invRight(%tog); }
	function invUp(%tog) { if (!RSC_cancelInvMove()) Parent::invUp(%tog); }
	function invDown(%tog) { if (!RSC_cancelInvMove()) Parent::invDown(%tog); }
	
	function PlayGui::createInvHUD(%playGui) { if (!$RSC::BlockBuilding) Parent::createInvHUD(%playGui); }
	function PlayGui::createToolHUD(%playGui) { if (!$RSC::BlockTools) Parent::createToolHUD(%playGui); }
	function PlayGui::loadPaint(%playGui) { if (!$RSC::BlockPainting) Parent::loadPaint(%playGui); }
	
	function scrollInventory(%val)
	{
		// bit of a hack - don't let the user scroll if the build menu would pick it up
		if (!$RSC::BlockBuilding || Canvas.isCursorOn() || HUD_ToolActive.isVisible() || HUD_PaintActive.isVisible())
			Parent::scrollInventory(%val);
	}
};
activatePackage("RSC_Tutorial");

function RSC_cancelInvMove()
{
	if (HUD_ToolActive.isVisible())
		return $RSC::BlockTools;
	else if (HUD_PaintActive.isVisible())
		return $RSC::BlockPainting;
	else
		return $RSC::BlockBuilding;
}

function clientcmdRSC_TutorialStage(%course, %stage)
{
	if (%course == -1)
	{
		$RSC::TutorialCourse = "";
		$RSC::TutorialStage = "";
		return;
	}
	if (%course == 0)
	{
		switch(%stage)
		{
			case 0:
				RSC_HUDLoop("0 0");
				HUD_BrickNameBG.setVisible(0);
				HUD_ToolNameBG.setVisible(0);
				HUD_PaintBox.setVisible(0);
				$RSC::BlockBuilding = 1;
				$RSC::BlockTools = 1;
				$RSC::BlockPainting = 1;
				$RSC::BlockClicking = 1;
				$RSC::BlockJumping = 1;
				$RSC::BlockJetting = 1;
				$RSC::BlockJetpack = 1;
				$RSC::TutorialActive = 1;
				%count = RSC_MainHUD.getCount();
				for (%i = 0; %i < %count; %i++)
				{
					RSC_MainHUD.getObject(%i).setVisible(0);
					if (!(%i & 1)) RSC_MainHUD.getObject(%i).forceHide = 1;
				}
				$RSC::TutorialCenterprint = 1;
				RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>Welcome to Realistic Space Mod! This tutorial will help you get acquainted with the basics of play.");
				schedule(5000, 0, "RSC_TutorialSpecial", 0);
			case 1:
				RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>Clicking on walls causes you to use them as a handhold. You can use handholds to swing around, or jump off, walls.");
				schedule(5000, 0, "RSC_TutorialSpecial", 1);
			case 2:
				RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>Well done! Now, by swinging around and jumping off handholds, move halfway around Spawn Station.");
			case 3:
				$RSC_TutorialArg0 = 0;
				RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>Now, it's time to head outside - but first, you must put on your helmet. Press <color:00FF00>Escape<color:FFFFFF> and follow the arrows.");
				RSC_ArrowGuide0();
			case 4:
				RSC_TutorialArrow.flashWhite = 1;
				RSC_ArrowGuideElement(RSC_MainHUD.getObject(1), "down");
				RSC_MainHUD.getObject(0).setVisible(1);
				RSC_MainHUD.getObject(1).setVisible(1);
				RSC_MainHUD.getObject(0).forceHide = 0;
				RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:24>At the top-right is your oxygen meter. If it begins to run low, re-enter Spawn Station and take off your helmet to refill it.<br><br><color:FF8000>WARNING<color:FFFFFF>: You will asphyxiate from lack of oxygen before the meter completely runs out!");
				schedule(15000, 0, "RSC_TutorialSpecial", 2);
			case 5:
				if (!isObject($SpawnStationCSG))
				{
					%airlock = CSG_Scale(CSG_Cube(), "1.5 2 1.5");
					$SpawnStationCSG = CSG_Union(CSG_Torus(20, 3.5), CSG_Union(CSG_Translate(%airlock, "0 25.5 0"), CSG_Translate(%airlock, "0 -25.5 0")));
				}
				if (MoveMap.getBinding("toggleJetpack") $= "")
				{
					openOptionsWindow(1);
					OptionsDlg.setPane("Controls");
					%remap = OptRemapList;
					%rows = %remap.rowCount();
					%remap.scrollVisible(%rows - 1);
					for (%i = 0; %i < %rows; %i++)
						if (%remap.getRowText(%i) $= "   \c4Realistic Space Client")
						{
							%remap.setSelectedRow(-1);
							%remap.scrollVisible(%i - 1);
						}
				}
				RSC_BindJetpackCheck();
			case 6:
				$RSC::BlockTools = 0;
				cancel($RSC::TutorialLoop);
				HUD_ToolNameBG.setVisible(1);
				RSC_UpdateDirMarker("TutorialCourse0", "DELETE");
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Grab onto the asteroid, and press " @ keybindToString("useTools", "<color:00FF00>") @ "<color:FFFFFF> to pull out your pickaxe.");
			case 7:
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Now, mine out 5 Ice and 4 Nitrogen from the asteroid.");
			case 8:
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Your inventory is full! Use <color:00FF00>/listmats<color:FFFFFF> to see what's in your inventory, and <color:00FF00>/dump<color:FFFF00> [amount] [material]<color:FFFFFF> to dump carbon or iron from your inventory.");
			case 9:
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Resume mining the asteroid until you have 5 Ice and 4 Nitrogen.");
			case 10:
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Now that you have 5 Ice and 4 Nitrogen, launch off the asteroid and head back for Spawn Station.");
			case 11:
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Re-enter Spawn Station and head to a Material Fabricator. Stop yourself while in front of it, then click on it to use it.");
				RSC_MatfabTutorial(0);
			case 12:
				cancel($RSC_TutorialDisplayLoop);
				clientcmdBottomPrint("<color:FFFFFF><just:center>You have completed <color:00FF00>Basic Training<color:FFFFFF>! Welcome to Realistic Space Mod.", 5, 1);
				$RSC::BlockBuilding = 0;
				$RSC::BlockPainting = 0;
				HUD_BrickNameBG.setVisible(1);
				HUD_PaintBox.setVisible(1);
				%count = RSC_MainHUD.getCount();
				for (%i = 0; %i < %count; %i++)
				{
					RSC_MainHUD.getObject(%i).setVisible(1);
					if (!(%i & 1)) RSC_MainHUD.getObject(%i).forceHide = 0;
				}
		}
	}
	if (%course == 1)
	{
		switch(%stage)
		{
			case 0:
				cancel($RSC_TutorialDisplayLoop);
				if ($RSC::TutorialCourse $= "0")
					clientcmdBottomPrint("<color:FFFFFF><just:center>You have completed <color:00FF00>Basic Training<color:FFFFFF>! Choose your species to finish.", 5, 1);
				else
					clientcmdBottomPrint("<color:FFFFFF>Choose your species.", 5, 1);
				$RSC::BlockBuilding = 0;
				$RSC::BlockPainting = 0;
				HUD_BrickNameBG.setVisible(1);
				HUD_PaintBox.setVisible(1);
				%count = RSC_MainHUD.getCount();
				for (%i = 0; %i < %count; %i++)
				{
					RSC_MainHUD.getObject(%i).setVisible(1);
					if (!(%i & 1)) RSC_MainHUD.getObject(%i).forceHide = 0;
				}
				Canvas.pushDialog(RSC_SpeciesGUI);
		}
	}
	$RSC::TutorialCourse = %course;
	$RSC::TutorialStage = %stage;
}

function RSC_BindJetpackCheck()
{
	cancel($RSC::TutorialLoop);
	if (MoveMap.getBinding("toggleJetpack") !$= "")
	{
		RSC_JetpackTutorial(0);
		Canvas.popDialog(OptionsDlg);
		$RSC::TutorialCenterprint = 1;
		RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>Now, launch yourself out of the airlock!");
	}
	else
	{
		$RSC::TutorialCenterprint = 0;
		RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:30><just:center>Bind a key to the Toggle Jetpack command.");
	}
	$RSC::TutorialLoop = schedule(16, 0, "RSC_BindJetpackCheck");
}

function clientcmdRSC_TutorialResponse(%code, %arg0, %arg1, %arg2, %arg3, %arg4)
{
	if (%code == 0)
		$RSC::TutorialArg25 = vectorSub(%arg0, $RSC::SSOffset);
}

function RSC_MatfabTutorial(%substage)
{
	cancel($RSC::TutorialLoop);
	if (%substage == 0)
		%matTarget = "Mat_Ice";
	else if (%substage == 1)
	{
		if (isEventPending(RSC_FabberArrow.burnSched))
		{
			RSC_ArrowGuideHide();
			%substage = 2;
		}
		else
			RSC_ArrowGuideElement(RSC_FabRecipeMenu.getObject(0), "left");
	}
	else if (%substage == 2)
	{
		if (!isEventPending(RSC_FabberArrow.burnSched))
		{
			RSC_ArrowGuideElement(Fabber_SlotOut1.getGroup(), "up");
			if (Fabber_SlotOut1.getObject(0).getValue() $= "<just:center>")
				%substage = 3;
		}
	}
	else if (%substage == 3)
		%matTarget = "Mat_Water";
	else if (%substage == 4)
	{
		if (isEventPending(RSC_FabberArrow.burnSched))
		{
			RSC_ArrowGuideHide();
			%substage = 5;
		}
		else
			RSC_ArrowGuideElement(RSC_FabRecipeMenu.getObject(0), "left");
	}
	else if (%substage == 5)
	{
		if (!isEventPending(RSC_FabberArrow.burnSched))
		{
			RSC_ArrowGuideElement(Fabber_SlotOut1.getGroup(), "up");
			if (Fabber_SlotOut1.getObject(0).getValue() $= "<just:center>")
				%substage = 6;
		}
	}
	else if (%substage == 6)
	{
		RSC_ArrowGuideElement(Fabber_SlotOut2.getGroup(), "up");
		if (Fabber_SlotOut2.getObject(0).getValue() $= "<just:center>")
			%substage = 7;
	}
	else if (%substage == 7)
		%matTarget = "Mat_Hydrogen";
	else if (%substage == 8)
		%matTarget = "Mat_Nitrogen";
	else if (%substage == 9)
	{
		if (isEventPending(RSC_FabberArrow.burnSched))
		{
			RSC_ArrowGuideHide();
			%substage = 10;
		}
		else
			RSC_ArrowGuideElement(RSC_FabRecipeMenu.getObject(0), "left");
	}
	else if (%substage == 10)
	{
		if (!isEventPending(RSC_FabberArrow.burnSched))
		{
			RSC_ArrowGuideElement(Fabber_SlotOut1.getGroup(), "up");
			if (Fabber_SlotOut1.getObject(0).getValue() $= "<just:center>")
				%substage = 11;
		}
	}
	else if (%substage == 11)
	{
		RSC_ArrowGuideElement(Fabber_SlotIn1.getGroup(), "up");
		if (Fabber_SlotIn1.getObject(0).getValue() $= "<just:center>")
			%substage = 12;
	}
	else if (%substage == 12)
	{
		RSC_ArrowGuideElement(Fabber_SlotIn2.getGroup(), "up");
		if (Fabber_SlotIn2.getObject(0).getValue() $= "<just:center>")
			%substage = 13;
	}
	else if (%substage == 13)
	{
		RSC_ArrowGuideHide();
		RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Now, use the command <color:00FF00>/refuel<color:FFFF00> 4<color:FFFFFF> to refuel your EVA tank with the hydrazine (N2H4) you have made.");
		return;
	}
	if (%matTarget !$= "")
	{
		%count = RSC_FabMatsMenu.getCount();
		for (%i = 0; %i < %count; %i++)
		{
			%obj = RSC_FabMatsMenu.getObject(%i);
			if (%obj.item $= %matTarget)
			{
				RSC_ArrowGuideElement(%obj, %i & 2 ? "right" : "left");
				%foundTarget = 1;
				break;
			}
		}
		if (!%foundTarget)
			%substage++;
	}
	$RSC::TutorialLoop = schedule(16, 0, "RSC_MatfabTutorial", %substage);
}

function RSC_JetpackTutorial(%substage)
{
	cancel($RSC::TutorialLoop);
	if (!isObject(%cl = ServerConnection) || !isObject(%pl = %cl.getControlObject())
		|| %pl.getClassName() !$= "Player" || %pl.getState() $= "DEAD")
		return;
	%relPos = vectorSub(%pl.getPosition(), $RSC::SSOffset);
	%offset = %pl.isCrouched() ? "0 0 0.5" : "0 0 1.325075";
	%hackPos = vectorAdd(%relPos, %offset);
	if (%substage == 0)
	{
		if (!$SpawnStationCSG.containsPoint(%hackPos))
		{
			$RSC::TutorialCenterprint = 0;
			$RSC::TutorialArg0 = getSimTime();
			%substage = 1;
		}
	}
	else if (%substage == 1)
	{
		RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>The green circle is which way you're going, and the red circle is which way you're moving away from.");
		if (ProgradeMarker.isVisible())
			RSC_ArrowGuideElement(ProgradeMarker, "down");
		else if (RetrogradeMarker.isVisible())
			RSC_ArrowGuideElement(RetrogradeMarker, "down");
		if (vectorDist($RSC::TutorialArg0, getSimTime()) > 8000 && vectorLen(%hackPos) > 40)
		{
			$RSC::BlockJetpack = 0;
			RSC_ArrowGuideHide();
			%substage = 2;
		}
	}
	else if (%substage == 2)
	{
		if (!$RSC::Jetpack)
			RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Press " @ keybindToString("toggleJetpack", "<color:00FF00>") @ "<color:FFFFFF> to toggle your jetpack.");
		else if (vectorLen(%pl.getVelocity()) < 0.5)
		{
			%radius = vectorLen(%hackPos);
			%axis0 = vectorNormalize(%hackPos);
			%axis1 = vectorNormalize(vectorCross("0 0 1", %axis0));
			%axis2 = vectorCross(%axis0, %axis1);
			$RSC::TutorialArg0 = 1;
			for (%i = 1; %i < 25; %i++)
			{
				%iVal = %i / 16 * 3.141592653;
				$RSC::TutorialArg[%i] = vectorAdd(vectorScale(%axis0, mCos(%iVal) * %radius), vectorScale(%axis1, mSin(%iVal) * %radius));
			}
			%contDir = vectorSub($RSC::TutorialArg24, $RSC::TutorialArg23);
			commandToServer('RSM_TutorialRequest', 0, vectorAdd($RSC::TutorialArg24, $RSC::SSOffset), %contDir);
			$RSC::TutorialArg25 = "0 0 0";
			%substage = 3;
		}
		else
			RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Look directly at the green indicator and press " @ keybindToString("moveBackward", "<color:00FF00>") @ "<color:FFFFFF> to slow down.");
	}
	else if (%substage == 3)
	{
		if ($RSC::TutorialArg0 == 1)
		{
			RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Look to your left and you will see a series of white indicators. Press " @ keybindToString("moveForward", "<color:00FF00>") @ "<color:FFFFFF> to begin moving for the first of these.");
			if (vectorLen(%pl.getVelocity()) > 5)
			{
				moveForward(0);
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>Stay below 10 studs per second unless you need to get somewhere as quickly as possible.");
			}
		}
		%start = $RSC::TutorialArg0;
		for (%i = 0; %i < 8; %i++)
		{
			if (%i + %start > 25)
				break;
			RSC_UpdateDirMarker("TutorialCourse" @ %i,
				vectorAdd($RSC::TutorialArg[%i + %start], $RSC::SSOffset),
				"1 1 1 " @ (1 / mPow(2, %i * 0.5)), %i == 0 ? "Course Marker" : "", 0.9975);
		}
		if (vectorDist(%hackPos, $RSC::TutorialArg[%start]) < 4)
		{
			if ($RSC::TutorialArg0 == 1)
			{
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>It's always wise to conserve fuel, shown in the upper right. Press " @
					keybindToString("moveLeft", "<color:00FF00>") @ "<color:FFFFFF> or " @ keybindToString("moveRight", "<color:00FF00>") @ "<color:FFFFFF> rather than " @
					keybindToString("moveForward", "<color:00FF00>") @ "<color:FFFFFF> when you want to make minor corrections to your course!");
				RSC_ArrowGuideElement(RSC_MainHUD.getObject(3), "down");
				RSC_MainHUD.getObject(2).setVisible(1);
				RSC_MainHUD.getObject(3).setVisible(1);
				RSC_MainHUD.getObject(2).forceHide = 0;
			}
			else if ($RSC::TutorialArg0 == 2)
				RSC_ArrowGuideHide();
			else if ($RSC::TutorialArg0 == 4)
			{
				RSC_TutorialDisplayLoop("<color:FFFFFF><just:center>To adjust your course up or down, press " @
					keybindToString("jump", "<color:00FF00>") @ "<color:FFFFFF> or " @ keybindToString("crouch", "<color:00FF00>") @ "<color:FFFFFF>.");
			}
			$RSC::TutorialArg0++;
			if (26 - $RSC::TutorialArg0 < 8)
				RSC_UpdateDirMarker("TutorialCourse" @ (26 - $RSC::TutorialArg0), "DELETE");
		}
	}
	
	// do stuff
	$RSC::TutorialLoop = schedule(16, 0, "RSC_JetpackTutorial", %substage);
}

function RSC_ArrowGuide0()
{
	cancel($RSC_ArrowGuide);
	$RSC_ArrowGuide = schedule(16, 0, "RSC_ArrowGuide0");
	%arrow = RSC_TutorialArrow;
	if (!EscapeMenu.isAwake())
		return;
	//%val = mSin($Sim::Time / 3.141592653 * 4) / 2 + 0.5;
	%val = getRealTime() & 512 ? 1 : 0;
	%arrow.setVisible(1);
	if (%arrow.flashWhite)
		%arrow.setColor("1 " @ %val SPC %val @ " 1");
	else
		%arrow.setColor(%val @ " 0 0 1");
	if (!OptionsDlg.isAwake())
	{
		if ($RSC_TutorialArg0)
		{
			HUD_BrickNameBG.setVisible(0);
			HUD_ToolNameBG.setVisible(0);
			HUD_PaintBox.setVisible(0);
			%arrow.getGroup().remove(%arrow);
			cancel($RSC_ArrowGuide);
			EscapeMenu.toggle();
			return;
		}
		%arrow.flashWhite = 1;
		EscapeMenu.add(%arrow);
		%menuPos = EM_Options.getGroup().getPosition();
		%menuExt = EM_Options.getGroup().getExtent();
		%x = getWord(%menuPos, 0) + getWord(%menuExt, 0) + 30;
		%y = getWord(%menuPos, 1) + getWord(EM_Options.getPosition(), 1) + mFloor(getWord(EM_Options.getExtent(), 1) / 2) - 40;
		%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Left");
		%arrow.resize(%x, %y, 80, 80);
		return;
	}
	if (!AvatarGui.isAwake())
	{
		%arrow.flashWhite = 0;
		OptionsDlg.getObject(0).add(%arrow);
		%avButton = OptNetworkPane.getID() - 2;
		%x = getWord(%avButton.getPosition(), 0) - 100;
		%y = getWord(%avButton.getPosition(), 1) + mFloor(getWord(%avButton.getExtent(), 1) / 2) - 40;
		%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Right");
		%arrow.resize(%x, %y, 80, 80);
		return;
	}
	%arrow.flashWhite = 0;
	Avatar_Window.add(%arrow);
	if ($Pref::Avatar::Hat != 1)
	{
		%target = Avatar_HatPreview;
		if (Avatar_HatMenu.isVisible())
			%target = Avatar_HatMenu.getObject(0).getObject(2);
	}
	else if ($Pref::Avatar::Accent != 1)
	{
		%target = Avatar_AccentPreview;
		if (Avatar_AccentMenu.isVisible())
			%target = Avatar_AccentMenu.getObject(0).getObject(2);
	}
	else if ($Pref::Avatar::Pack != 6)
	{
		%target = Avatar_PackPreview;
		if (Avatar_PackMenu.isVisible())
			%target = Avatar_PackMenu.getObject(0).getObject(12);
	}
	if (!isObject(%target))
	{
		%target = Avatar_SymmetryCheckbox.getID() - 3;
		%x = getWord(%target.getPosition(), 0) + mFloor(getWord(%target.getExtent(), 0) / 2) - 40;
		%y = getWord(%target.getPosition(), 1) - 84;
		%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Down");
		%arrow.resize(%x, %y, 80, 80);
		$RSC_TutorialArg0 = 1;
		return;
	}
	%x = getWord(%target.getPosition(), 0) + mFloor(getWord(%target.getExtent(), 0) / 2) - 40;
	%y = getWord(%target.getPosition(), 1) + getWord(%target.getExtent(), 1) + 4;
	while (isObject(%parent = %target.getGroup()) && %parent.getName() !$= "Avatar_Window")
	{
		%pos = %parent.getPosition();
		%x += getWord(%pos, 0);
		%y += getWord(%pos, 1);
		%target = %parent;
	}
	%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Up");
	%arrow.resize(%x, %y, 80, 80);
}

function RSC_ArrowGuideElement(%target, %pos)
{
	cancel($RSC_ArrowGuide);
	if (!isObject(%target))
		return;
	$RSC_ArrowGuide = schedule(16, 0, "RSC_ArrowGuideElement", %target, %pos);
	%arrow = RSC_TutorialArrow;
	%arrow.setVisible(1);
	%val = getRealTime() & 512 ? 1 : 0;
	if (%arrow.flashWhite)
		%arrow.setColor("1 " @ %val SPC %val @ " 1");
	else
		%arrow.setColor(%val @ " 0 0 1");
	%target.getGroup().add(%arrow);
	switch$(%pos)
	{
		case "up":
			%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Up");
			%x = getWord(%target.getPosition(), 0) + mFloor(getWord(%target.getExtent(), 0) / 2) - 40;
			%y = getWord(%target.getPosition(), 1) + getWord(%target.getExtent(), 1) + 4;
		case "left":
			%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Left");
			%x = getWord(%target.getPosition(), 0) + getWord(%target.getExtent(), 0) + 4;
			%y = getWord(%target.getPosition(), 1) + mFloor(getWord(%target.getExtent(), 1) / 2) - 40;
		case "down":
			%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Down");
			%x = getWord(%target.getPosition(), 0) + mFloor(getWord(%target.getExtent(), 0) / 2) - 40;
			%y = getWord(%target.getPosition(), 1) - 84;
		case "right":
			%arrow.setBitmap("Add-Ons/Client_RealisticSpace/GUIs/Tutorial Icons/Arrow_Right");
			%x = getWord(%target.getPosition(), 0) - 84;
			%y = getWord(%target.getPosition(), 1) + mFloor(getWord(%target.getExtent(), 1) / 2) - 40;
	}
	%arrow.resize(%x, %y, 80, 80);
}

function RSC_ArrowGuideHide()
{
	cancel($RSC_ArrowGuide);
	%arrow = RSC_TutorialArrow;
	if (isObject(%arrow.getGroup()))
		%arrow.getGroup().remove(%arrow);
}

function RSC_TutorialSpecial(%case)
{
	if (%case == 0)
	{
		RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>First, look at a nearby wall and press " @ keybindToString("mouseFire", "<color:00FF00>") @ "<color:FFFFFF> to grab it.");
		$RSC::BlockClicking = 0;
	}
	else if (%case == 1)
	{
		RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>Press " @ keybindToString("jump", "<color:00FF00>") @ "<color:FFFFFF> to jump off from your handhold now.");
		$RSC::BlockJumping = 0;
	}
	else if (%case == 2)
	{
		RSC_TutorialDisplayLoop("<color:FFFFFF><font:arial:36>Start heading for the airlock so you can get outside. Press the glowing buttons to cycle the airlock.");
		$RSC::BlockJetting = 0;
		RSC_ArrowGuideHide();
	}
}

function RSC_TutorialDisplayLoop(%msg)
{
	cancel($RSC_TutorialDisplayLoop);
	if ($RSC::TutorialCenterprint)
		clientcmdCenterprint(%msg, 5);
	else
		clientcmdBottomprint(%msg, 5, 1);
	$RSC_TutorialDisplayLoop = schedule(100, 0, "RSC_TutorialDisplayLoop", %msg);
}