$RSC::Revision += 1;

function clientcmdRSC_Interact(%data, %token, %arg0, %arg1, %arg2, %arg3, %arg4)
{
	%bind = MoveMap.getBinding("RSC_InteractWith");
	if(%bind $= "")
	{
		MoveMap.bind("keyboard", "x", "RSC_InteractWith");
		%bind = "keyboard\tx";
	}
	%base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	for(%i=0;%i<4;%i++)
	{
		%pos = strPos(%base64, getSubStr(%data, %i, 1));
		if(%pos == -1) { %final = -1; break; }
		%final <<= 6;
		%final |= %pos;
	}
	%press = keybindToString("RSC_InteractWith", "\c3");
	switch(%final)
	{
		case -1: clientcmdBottomPrint("", 0, 1);
		case 0: %msg = "to interact with "@(%arg1$=""?"":%arg1@" ")@"\c3"@%arg0@"\c2.";		//AAAA
		case 1: %msg = "to interact with \c3"@%arg0@" Core\c2.";				//AAAB
		case 2: %msg = "to use the \c3material fabricator\c2.";					//AAAC
		case 3: %msg = "to \c3enter stasis\c2.";						//AAAD
		case 4: %msg = "to tether to \c3"@%arg0@"\c2.";						//AAAE
		default: echo("\c4Realistic Space Client\c1: \c0Got unknown interact listing.");
			 echo("If you're seeing this message, update your client.");
	}
	if(%final == -1) $RSC::InteractToken = "";
	else
	{
		clientcmdBottomPrint("\c2Press "@%press@"\c2 "@%msg, -1, 1);
		$RSC::InteractToken = %token;
	}
}

function RSC_InteractWith(%tog)
{
	//The token keeps us from accidentally interacting with something we didn't want to.
	if(%tog) commandToServer('RSM_Interact', $RSC::InteractToken);
}

function keybindToString(%command, %colorCode)
{
	%bind = MoveMap.getBinding(%command);
	if (%bind $= "")
		return "the " @ %colorCode @ %command @ " command";
	%device = getField(%bind, 0);
	%action = getField(%bind, 1);
	if (%device $= "mouse0")
	{
		if (%action $= "button0")
			return "the " @ %colorCode @ "left mouse button";
		else if (%action $= "button1")
			return "the " @ %colorCode @ "right mouse button";
		else if (%action $= "button2")
			return "the " @ %colorCode @ "middle mouse button";
		else if (striPos(%action, "button") == 0)
			return %colorCode @ "mouse button " @ (getSubStr(%action,6,strLen(%action)-6)+1);
		else
			return %colorCode @ %action;
	}
	else
	{
		%words = getWordCount(%action);
		for (%i = 0; %i < %words; %i++)
		{
			%word = getWord(%action, %i);
			if (%word $= "")
				continue;
			%word = strUpr(getSubStr(%word, 0, 1)) @ strLwr(getSubStr(%word, 1, strLen(%word) - 1));
			%action = setWord(%action, %i, %word);
		}
		return %colorCode @ %action;
	}
}

if(!$RealisticSpaceClientBound)
{
	$remapName[$remapCount++] = "Interact With Entity";
	$remapCmd[$remapCount] = "RSC_InteractWith";
}